/*
Copyright ESIEE (2009) 

m.couprie@esiee.fr

This software is an image processing library whose purpose is to be
used primarily for research and teaching.

This software is governed by the CeCILL  license under French law and
abiding by the rules of distribution of free software. You can  use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
*/
/* $Id: mcfahdouble.h,v 1.3 2006/02/28 07:49:12 michel Exp $ */

typedef struct FAHDELT {
  int32_t Point1;
  int32_t Point2;
  struct FAHDELT * Next;
} FahdElt;

#define NPRIO 256

typedef struct {
  int32_t Max;             /* taille max de la fahd (en nombre de points) */
  int32_t Niv;             /* niveau a partir duquel des listes existent */
  int32_t Util;            /* nombre de points courant dans la fahd */
  int32_t Maxutil;         /* nombre de points utilises max */
  FahdElt *Tete[NPRIO]; /* tableau des tetes de liste (la ou l'on insere) */
  FahdElt *Queue;       /* queue de liste (la ou l'on preleve) */
  FahdElt *Libre;       /* pile des cellules libres */
  FahdElt Elts[1];      /* tableau des elements physiques */
} Fahd;

/* ============== */
/* prototypes     */
/* ============== */

extern Fahd * CreeFahdVide(
  int32_t taillemax
);

extern void FahdFlush(
  Fahd * L
);

extern int32_t FahdVide(
  Fahd * L
);

extern int32_t FahdVideUrg(
  Fahd * L
);

extern int32_t FahdVideNiveau(
  Fahd * L,
  int32_t niv
);

extern int32_t FahdNiveau(
  Fahd * L
);

extern void FahdPop(
  Fahd * L,
  int32_t *P1,
  int32_t *P2
);

extern void FahdFirst(
  Fahd * L,
  int32_t *P1,
  int32_t *P2
);

extern void FahdPush(
  Fahd * L,
  int32_t P1,
  int32_t P2,
  int32_t Ni
);

extern void FahdTermine(
  Fahd * L
);

extern void FahdPrint(
  Fahd * L
);
